'-----------------------------------------------------------------------------------------
'name                       : MidiJowoTest2.bas         Stand 17.11.2014
'copyright                : (c) 2014 JoWo
'purpose                   : Midi-Schalter-Eingabe mit LCD Basics for Pollin Spiel
'micro                       : ATtiny 2313
'commercial addon needed  : no
'-----------------------------------------------------------------------------------------

$regfile = "ATtiny2313.DAT"                                 ' specify the used micro
$crystal = 1000000                                          ' used crystal frequency
$baud = 31250                                               ' use MIDI-baud rate
$hwstack = 32                                               ' default use 32 for the hardware stack
$swstack = 10                                               ' default use 10 for the SW stack
$framesize = 40                                             ' default use 40 for the frame space

' **********************************************************************************************
'Vereinbarungen fr Midi-Taster

Taster Alias Pind.2                                         ' EIN-Taster im Pollin-Spiel als Ausgabe-Taster fr Midi-Signal

Dim Keydown As Byte                                         ' Tasten-Merker   fr Midi-Eingabe

Ddrd.1 = 1                                                  ' Sendeleitung von Port D1  auf Output stellen
Portd.2 = 1                                                 ' internen Pull-Up aktivieren fr Taster

'********************************
'Alias Namen vergeben    fr LCD-Initialisierung
Lcd_ein Alias Portd.6
Config Lcd_ein = Output                                     'Vorbereitung Senden PortB6 fr Versorgungsspannung VDD  fr LCD einschalten?

Lcd_kontrast Alias Portb.4
Config Lcd_kontrast = Output                                'Vorbereitung Senden PortB4  fr Kontrast --> Kontrastspannung Vo einschalten?
Config Lcdmode = Port                                       ' LCD im 4-bit- Port Modus  betreiben (statt im Bus-Modus)

Config Lcd = 16 * 2 , Chipset = Ks077                       'Wichtigster Kunstgriff fr das Pollin-Display!!!  Chipsatz KS077 ist da drin

Config Lcdbus = 4                                           'Ansteuerung ber 4-bit-Datenbus; Befehl notwendig, wenn v o r h e r (!)   Lcdmode = port eingegeben wurde.

'Befehl Config Lcdpin MUSS !!!  immer in EINE  Zeile geschrieben werden, egal wie lang das Ganze ist, sonst klappt es  nicht!!! :
Config Lcdpin = Pin , Db4 = Portb.0 , Db5 = Portb.1 , Db6 = Portb.2 , Db7 = Portb.3 , E = Porta.0 , Rs = Porta.1
'**************************************************************************************************

'-----------------------------
'  deklarationen
'-----------------------------

Declare Sub Init                                            ' Deklarieren Unterprogramme (hier fr Initialisierung LCD)  ist ntig, sonst findet das Hauptprogramm sie nicht.
Declare Sub Keypressed                                      ' Deklarieren des Unterprogramms fr Taster-Abfrage
'*****************************************************************
'*****************************************************************
'Beginn Hauptprogramm


Call Init                                                   ' LCD Initialisieren

Cls
Locate 1 , 1                                                'Textanfang  positionieren auf 1.Zeile und 1. Zeichen
Lcd "Hallo"
Wait 2
Locate 2 , 1
Lcd "Niels! "
Wait 1
  ' Ende des Hauptprogramm-Teils LCD


 ' Beginn Programm-Schleife Taster-Abfrage fr MIDI
 Taster = 1

  Do
    Debounce Pind.2 , 0 , Keypressed , Sub                  ' ob 0 oder 1 vor keypressed in debounce-Funktion ntig, hngt vom schalter ab, in welchem  zustand: low oder high-Flanke wenn gedrckt?
    If Taster = 0 Then                                      'debounce-Befehl bei mechanischen Taster zur Entprellung benutzen: Befehl debounce PORTx.y, sub-name, sub   ( sub vor Hauptprogramm deklarieren)
      If Keydown = 1 Then
        Cls
        Locate 2 , 1
         Gosub Sendmidinoteoff

         Lcd "Ta. aus"
          Keydown = 0
       End If
    Else
      If Keydown = 0 Then
        Cls
        Locate 1 , 1
        Lcd "Ta. gedr."
        Gosub Sendmidinoteon

         Keydown = 1
       End If
    End If
    Waitms 20                                               ' Wait-Status scheint erforderlich,. sonst hat Chip offenbar zu wenig Zeit und  sendet  keine Midi-Daten!!!!
    Loop

 End                                                        'Ende  des Hauptprogramms
'*****************************************************************
'*****************************************************************
Sendmidinoteon:
  Print Chr(&B10010010);                                    ' NOTE-ON-Command:  Kanal 3 ist bei BIAB das Piano, Kanal 10 Drums
  Print Chr(69);                                            ' Tasten-Nummer 69 (Note A 3)
  Print Chr(100);                                           ' Key-Down-Velocity 100
Return

Sendmidinoteoff:
  Print Chr(&B10000010);                                    ' NOTE-OFF-Command:      jetzt auf Kanal 3
  Print Chr(69);                                            ' Tasten-Nummer 69 (Note A 3)
  Print Chr(0);                                             ' Release-Velocity 0 (Default)
Return


'-----------------------------
'   func/subs
'-----------------------------

Sub Init                                                    'Unterprogramm Initialisieren LCD

 Set Lcd_ein
 Set Lcd_kontrast

 Initlcd
 Cursor Off
 Cls

End Sub

Sub Keypressed                                              ' Unterprogramm Taster-Abfrage
         Taster = 0
         Keydown = 1
End Sub

'**********************************************************************
'       ENDE DES GESAMTEN PROGRAMMS

'**********************************************************************

'SONSTIGE KOMMENTARE ZUM THEMA MIDI


 'brige Variablen und Konstanten Definitionen:
' andere Ports als Schalter konfigurieren
' 1 Port ais Midi-Ausgang konfigureren --> Rs232 etc.  --> Software-Uart oder was geht noch?
' falls Speicher  nicht reicht --> ATtiny 4313 nehmen: ist pinkompatibel hat aber doppelt sovielSpeicher wie ATtiny2313, d.h. 4k Bytes
'SEROUT var , bts , port , pin, baud , parity , dbits , sbits    srielles Uart, geht auch fr SERIN auf geleichem pin im Wechsel

'****************************************************************************************
'Progr.Beispiel Serin/Serout fr Midi nutzbares Software-Uart
'*****************************************************************************************
' vorher noch Baud-Fehler kalkulieren und die crystal-Frequenz ggfs. von Standard 1 Mhz ohne Quarz auf 4 MHZ mit Quarz(?)ndern?
' baud: Hilfe Bascom: Beispiel   Config Com1 = Dummy, Synchrone = 0, Parity = None, Stopbits = 1, Databits = 8, Clockpol = 0
'UART :
'The statements that support the device are PRINT , INPUT , INPUTHEX , INKEY and WAITKEY
'Every opened device must be closed using the CLOSE #channel statement. Of course, you must use the same channel number.

' Ich wrde dir drigend empfehlen die empfangenen Daten in einer Statemachine zu verarbeiten und nicht "blind" einfach jedes zweite Byte
'    "fressen".
'Wenn Die Futreter Einen Running -status Sendet (oxfe Glaub Ich) , Oder die Daten "komprimiert" Sendet,  Dann Funktioniert Deine Vorgehensweise
'nicht.
'Einfach Eine STATEMACHINE Implementieren,  Die Im Startzustand Auf Einprogram -change Befehl "wartet" , Dann In Einen Anderen Zustand
'Weiterschaltet,  Indem Dein Datenbyte Ausgewertet Wird. Ist Der Befehl Komplett "durchgelaufen" Wieder In Den Ersten Zustand Auf Ein Erneutes
'  "Program -change "Warten. Sich Bei Midi Darauf Zu Verlassen Dass Jedes Zweite Byte Dies Und Das Ist
'nur weil man nur diese Befehlstypen erwartet geht zu 120% in die Hose!!!    Die Baud-Rate bei MIDI ist 31,25 kBit.


'***************************************************************************************
'wenn Datei .bin fehlt in Bascom-Compiler-Nachricht, dann mglicherweise wurde ist die Installation ohne Admin-Rechte ausgefhrt.
'Rechte Maustaste - > Als Administrator Ausfhren.


' Die Lsung war, BASCOM einfach irgendeine
'Datei zu geben und diese umzubenennen.
'in .BIN oder .HEX, das weiss nicht nicht mehr genau.
'Vor dem Punkt natrlich dein Programm-Dateiname.
'
'Dann sollte BASCOM zufrieden sein.
 'habe jetzt zwei alte sicherungsdateien gleichen namens jeweils in
 'hex und in .bin umbenannt, jetzt geht die kiste. das war die lsung!
 '*****************************************************************************************
'Noch ein Programmiervorschlag fr Midi-Ausgabe :
'$regfile "m8def.dat"
'$crystal = 8000000

'$baud = 31250


'Dim Voice As Byte
'Dim Cntrnr As Byte
'Dim Vals As Byte

'Config Portd.7 = Output

'Voice = &H90
'Cntrnr = &H3C
'Vals = &H7F

'Do

'Toggle Portd.7
'Print Chr(voice);                                           'senden der drei bytes
'Print Chr(cntrnr);
'Print Chr(vals);
'Wait 1
'Loop

'End

'************************************************************Ende de Progr.vorschlags ***